package com.example.andersb.httpconnectionexample;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;


public class HttpConnectionActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_http_connection);
        DownloadImageTask imageTask = new DownloadImageTask();
        imageTask.execute("http://laerer.rhs.dk/andersb/cv/andersBorjesson.jpg");
        DownloadTextTask textTask = new DownloadTextTask();
        textTask.execute("http://laerer.rhs.dk/andersb/");
    }


    private class DownloadImageTask extends AsyncTask<String, Void, Bitmap> {
        @Override
        protected Bitmap doInBackground(String... urls) {
            try {
                return downloadImage(urls[0]);
            } catch (IOException ex) {
                Log.e("SHIT", "DownloadImageTask: " + ex.toString());
                throw new RuntimeException(ex);
            }
        }

        @Override
        protected void onPostExecute(Bitmap bitmap) {
            ImageView img = (ImageView) findViewById(R.id.img);
            img.setImageBitmap(bitmap);
        }
    }

    private Bitmap downloadImage(String urlString) throws IOException {
        InputStream in = openHttpConnection(urlString);
        Bitmap bitmap = BitmapFactory.decodeStream(in);
        return bitmap;
    }

    private class DownloadTextTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... urls) {
            try {
                return downloadText(urls[0]);
            } catch (IOException ex) {
                Log.e("SHIT", "DownloadImageTask: " + ex.toString());
                throw new RuntimeException(ex);
            }
        }

        @Override
        protected void onPostExecute(String text) {
            TextView view = (TextView)findViewById(R.id.text);
            view.setText(text);
        }
    }

    private String downloadText(String url) throws IOException{
        InputStream in = openHttpConnection(url);
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        StringBuilder stringBuilder = new StringBuilder();
        while (true) {
            String line = reader.readLine();
            if (line == null) break;
            stringBuilder.append(line);
        }
        return stringBuilder.toString();
    }

    private InputStream openHttpConnection(String urlString) throws IOException {
        URL url = new URL(urlString);
        URLConnection conn = url.openConnection();
        if (!(conn instanceof HttpURLConnection)) {
            throw new IOException("Not an HTTP connection");
        }
        HttpURLConnection httpConn = (HttpURLConnection) conn;
        httpConn.setAllowUserInteraction(false); // No user interaction like dialogs, etc.
        httpConn.setInstanceFollowRedirects(true);    // follow redirects, response code 3xxx
        httpConn.setRequestMethod("GET");
        httpConn.connect();
        int responseCode = httpConn.getResponseCode();
        if (responseCode == HttpURLConnection.HTTP_OK) {
            return httpConn.getInputStream();
        } else {
            throw new IOException("HTTP response not OK");
        }
    }


}
